package elasticsearch

import (
	"bytes"
	"encoding/json"
	"fmt"
	"reflect"
	"regexp"
)

func Migrate(dst ...interface{}) {
	for _, d := range dst {
		fmt.Println(d)
		Field(d)
	}
}

func Field(dst interface{}) {
	typeOfCat := reflect.TypeOf(dst)
	of := typeOfCat.Elem()
	for i := 0; i < of.NumField(); i++ {
		// 获取每个成员的结构体字段类型
		field := of.Field(i)
		// 输出成员名和tag
		tag := field.Tag
		js := field.Tag.Get("json")
		es := field.Tag.Get("es")
		fmt.Println(tag)
		fmt.Println(js)
		fmt.Println(es)
		fmt.Printf("name: %v  tag: '%v'\n", js, field.Tag)
	}
}

func MarshalJSON(obj interface{}) ([]byte, error) {
	// Regexp definitions
	var keyMatchRegex = regexp.MustCompile(`\"(\w+)\":`)
	var wordBarrierRegex = regexp.MustCompile(`(\w)([A-Z])`)
	marshalled, err := json.Marshal(obj)
	converted := keyMatchRegex.ReplaceAllFunc(
		marshalled,
		func(match []byte) []byte {
			return bytes.ToLower(wordBarrierRegex.ReplaceAll(
				match,
				[]byte(`${1}_${2}`),
			))
		},
	)
	return converted, err
}
